<?php declare(strict_types=1);

namespace Plugin\km_artikelpreise\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;

class Migration20211206200000 extends Migration implements IMigration
{	
    public function up()
    {

		//Jetzt immer anlegen, damit es im Plugin nicht mehr als geprüft werden muss, je nach Rechten geht das auch leider nicht sauber
		$this->getDB()->query("CREATE TABLE IF NOT EXISTS `km_plugin_settings` (
			  `setting` varchar(50) NOT NULL PRIMARY KEY,
			  `value` TEXT NOT NULL
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			
		//Name für Manipulationen vergeben, falls gewünscht
        $this->execute("ALTER TABLE xplugin_km_artikelpreise_manipulation ADD COLUMN name VARCHAR(250) AFTER kArtikel;");
		
		//Für "globale" Artikel, auf Attribut statt kArtikel reagieren
        $this->execute("ALTER TABLE xplugin_km_artikelpreise_basics DROP PRIMARY KEY;");
        $this->execute("ALTER TABLE xplugin_km_artikelpreise_basics ADD COLUMN fktattr VARCHAR(150) AFTER kArtikel;");
        $this->execute("ALTER TABLE xplugin_km_artikelpreise_manipulation ADD COLUMN fktattr VARCHAR(150) AFTER kArtikel;");
        $this->execute("ALTER TABLE xplugin_km_artikelpreise_variationen ADD COLUMN fktattr VARCHAR(150) AFTER kArtikel;");
		
		//min, max und steps bei feldern zu varchar, damit funktionsattribute genutzt werden können
		$this->execute("ALTER TABLE xplugin_km_artikelpreise_variationen CHANGE min min VARCHAR(150);");
		$this->execute("ALTER TABLE xplugin_km_artikelpreise_variationen CHANGE max max VARCHAR(150);"); 
		$this->execute("ALTER TABLE xplugin_km_artikelpreise_variationen CHANGE step step VARCHAR(150);");
		$this->execute("ALTER TABLE xplugin_km_artikelpreise_variationen CHANGE einheit einheit VARCHAR(150);");
    }

    public function down()
    {
        //Nothing to Do
    } 
}